'****************************************************************************
'
' SpamProxy    : LOGFILE.BAS (Logfile-Routines)
' Version      : 0.22
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: http://www.gohel.de
' Last Updates : see directly in the sources
'
'****************************************************************************

DECLARE FUNCTION Get_CfgEntry(BYVAL Cfg AS STRING, BYVAL Match AS STRING, BYVAL CfgDefault AS STRING, BYVAL XP AS LONG) AS STRING
DECLARE FUNCTION Get_CfgFlag(BYVAL Cfg AS STRING) AS LONG

DECLARE FUNCTION LogHandle(BYVAL LogFile AS STRING) AS LONG
DECLARE FUNCTION LogIntro() AS STRING
DECLARE FUNCTION LogDate AS STRING
DECLARE SUB Get_AppPath()
'DECLARE SUB LogWrite(TEXT AS STRING, LogThread AS LONG, LogState AS INTEGER)
DECLARE FUNCTION PBVersion AS STRING

%LogState_Normal      = 0                '
%LogState_FatalError  = 1                ' !
%LogState_OtherError  = 2                ' ?
%LogState_CostInfo    = 3                ' $
%LogState_Filenames   = 4                '
%LogState_Routing     = 5                ' : (Port-Listen/IPs
%LogState_BriefMsg    = 6                '
%LogState_Filter      = 7                ' - (Minus fr Filter)
%LogState_TransStat   = 8                '
%LogState_SessionInfo = 9                ' ~ (Connect/Disconnect)
%LogState_RasDialResp = 10               '
%LogState_Debug       = 255              '

'-------------------------------------------------------------------------------------------
' SpamProxy Logfile ffnen und diverse Sicherheitsabfragen durchfhren/vorbereiten
'-------------------------------------------------------------------------------------------
SUB LogOpen()

        LOCAL sLogAppDeb AS STRING        '
        LOCAL PrxyLogDir AS STRING        ' Log-Verzeichnis fr SpamProxy
        LOCAL hCfg       AS LONG          ' Handle der SPAMPRXY.CFG
        LOCAL Cfg        AS STRING        '
        LOCAL LogDir     AS STRING        ' Verzeichnis in denen die Logfiles geschreiben werden
        LOCAL Temp       AS STRING        '
        LOCAL i          AS LONG

        ON ERROR RESUME NEXT

        hLogFile   = -1                   ' SpamProxy Logfile

        Get_AppPath

        sLogAppDeb = REMOVE$(sLogApp$, " ")

        IF LEN(DIR$(AppPath + "SPAMPRXY.CFG")) > 0 THEN
            hCfg = FREEFILE               ' SPAMPRXY.CFG einlesen
            OPEN AppPath + "SPAMPRXY.CFG" FOR BINARY AS #hCfg
            GET$ #hCfg, 16024, Cfg$
            CLOSE #hCfg
            Cfg$             = Cfg$ + CHR$(13, 10)
            Pop3Timeout      = VAL(Get_CfgEntry$(Cfg$, "Pop3Timeout=", "60", %True))
            NntpTimeout      = VAL(Get_CfgEntry$(Cfg$, "NntpTimeout=", "600", %True))
            Pop3PortIncoming = VAL(Get_CfgEntry$(Cfg$, "Pop3PortIncoming=", "110", %True))
            Pop3PortOutgoing = VAL(Get_CfgEntry$(Cfg$, "Pop3PortOutgoing=", "110", %True))
            KillReport       = Get_CfgEntry$(Cfg$, "KillReport=", "killreport@localhost", %True)
            NntpPortIncoming = VAL(Get_CfgEntry$(Cfg$, "NntpPortIncoming=", "119", %True))
            NntpPortOutgoing = VAL(Get_CfgEntry$(Cfg$, "NntpPortOutgoing=", "119", %True))
            LogDir$          = Get_CfgEntry$(Cfg$, "LOGDIR=", AppPath, %True)
            LogFilter&       = Get_CfgFlag(Get_CfgEntry$(Cfg$, "LogFilter=", "J", %True))
            LogSession&      = Get_CfgFlag(Get_CfgEntry$(Cfg$, "LogSession=", "J", %True))
            LogDebug&        = Get_CfgFlag(Get_CfgEntry$(Cfg$, "LogDebug=", "N", %True))
            Debugline&       = Get_CfgFlag(Get_CfgEntry$(Cfg$, "DEBUGLINE=", "N", %True))
            Killfile$        = Get_CfgEntry$(Cfg$, "KILLFILE=", "KILLFILE.CFG", %True)

            '--[Debug-Mode aktiviert]-----------------------------------------------------------
            hLogFile = LogHandle(LogDir$ + "SPAMPRXY.LOG")       ' eigenes LogFile ffnen
            IF hLogFile > 0 THEN
                PRINT #hLogFile, LogIntro
            END IF
        END IF
END SUB

'-------------------------------------------------------------------------------------------
' Handle fr Logfile holen
'-------------------------------------------------------------------------------------------
FUNCTION LogHandle(BYVAL LogFile AS STRING) AS LONG

        LOCAL hLog           AS LONG      '
        ON ERROR GOTO LogHandleError

        hLog = FREEFILE
        OPEN LogFile$ FOR APPEND AS #hLog
        FUNCTION = hLog
        EXIT FUNCTION

LogHandleError:
        FUNCTION = -1
END FUNCTION

'-------------------------------------------------------------------------------------------
' gemeinsames Intro fr Logfile
'-------------------------------------------------------------------------------------------
FUNCTION LogIntro AS STRING

        LOCAL Temp       AS STRING        '

        Temp$ = "----------  " + LogDate$ + ", SpamProxy " + Version$ + " - (compilation by Thomas Gohel / 2002)"

        IF LogDebug& = %True THEN
            Temp$ = Temp$ + CrLf$ + "  "+ TIME$ + "     : " + _
                    "Debug-Mode activated"
        END IF
        FUNCTION = Temp$

END FUNCTION

'-------------------------------------------------------------------------------------------
' Schreiben der Logfiles
'-------------------------------------------------------------------------------------------
SUB LogWrite(Text AS STRING, LogThread AS LONG, LogState AS INTEGER)

        DIM sThread    AS STRING
        DIM sLogState  AS STRING
        DIM hLogWrite  AS INTEGER
        DIM LogInfo    AS STRING

        IF LogThread& >= 0 THEN
            sThread = "#" + FORMAT$(LogThread&, "00")
        ELSE
            sThread = "   "
        END IF

        SELECT CASE LogState%
            CASE   0: sLogState = "  ": hLogWrite% = %True
            CASE   1: sLogState = "! ": hLogWrite% = %True
            CASE   2: sLogState = "? ": hLogWrite% = %True
            CASE   3: sLogState = "$ ": hLogWrite% = %True
            CASE   4: sLogState = "* ": hLogWrite% = %False
            ' Routing/IPs
            CASE   5: sLogState = ": "
                      IF LogSession = %True THEN
                          hLogWrite% = %True
                      ELSE
                          hLogWrite% = %False
                      END IF
            CASE   6: sLogState = "+ ": hLogWrite% = %True
            ' Filter
            CASE   7: sLogState = "- "
                      IF LogFilter = %True THEN
                          hLogWrite% = %True
                      ELSE
                          hLogWrite% = %False
                      END IF
            CASE   8: sLogState = "% ": hLogWrite% = %True
            ' Connect/Disonect
            CASE   9: sLogState = "~ "
                      IF LogSession = %True THEN
                          hLogWrite% = %True
                      ELSE
                          hLogWrite% = %False
                      END IF
            CASE  10: sLogState = "= ": hLogWrite% = %True
            CASE 255: sLogState = "  "
                      IF LogDebug = %True THEN
                          hLogWrite% = %True
                      ELSE
                          hLogWrite% = %False
                      END IF
        END SELECT

        IF hLogWrite% = %TRUE THEN
            IF LogState% < 255 THEN
                ' Nur Ausgabe bei reinen Console-Anwendungen
                $IF %PBWriteCon
                STDOUT Text$
                $ENDIF
            END IF
            LogInfo = sLogState + TIME$ + "  " + sThread + ": " + Text$
            IF hLogFile > 0 THEN
                PRINT #hLogFile, LogInfo
            END IF
            'IF hXPFile > 0 THEN
            '    PRINT #hXPFile, LogInfo
            'END IF
        END IF
END SUB

'-------------------------------------------------------------------------------------------
' Logfile(s) schliessen
'-------------------------------------------------------------------------------------------
SUB LogClose
        IF hLogFile > 0 THEN
            CLOSE #hLogFile          ' UKAW Logfile schliessen
        END IF
        'IF hXPFile > 0 THEN
        '    CLOSE #hXPFile           ' XP2 Logfile schliessen
        'END IF
END SUB

'-------------------------------------------------------------------------------------------
' Datums/Zeiteintrge fr Logfile generieren
'-------------------------------------------------------------------------------------------
FUNCTION LogDate AS STRING

        LOCAL LogFormat    AS STRING
        LOCAL LogDayOfWeek AS STRING
        LOCAL LogDay       AS STRING
        LOCAL LogYear      AS STRING
        LOCAL LogXPMonth   AS STRING
        LOCAL LogFDMonth   AS STRING
        LOCAL SystemDatum  AS SYSTEMTIME

        GetLocalTime SystemDatum

        SELECT CASE SystemDatum.wDayOfWeek
            CASE 0: LogDayOfWeek$ = "Sun"
            CASE 1: LogDayOfWeek$ = "Mon"
            CASE 2: LogDayOfWeek$ = "Tue"
            CASE 3: LogDayOfWeek$ = "Wed"
            CASE 4: LogDayOfWeek$ = "Thu"
            CASE 5: LogDayOfWeek$ = "Fri"
            CASE 6: LogDayOfWeek$ = "Sat"
        END SELECT

        LogDay$ = FORMAT$(SystemDatum.wDay,"##")
        REPLACE " " WITH "0" IN LogDay$

        LogXPMonth$ = FORMAT$(SystemDatum.wMonth,"##")
        REPLACE " " WITH "0" IN LogXPMonth$

        LogFormat$ = UCASE$(ENVIRON$("UKAWLOG"))

        SELECT CASE SystemDatum.wMonth
            CASE  1: LogFDMonth$ = "Jan"
            CASE  2: LogFDMonth$ = "Feb"
            CASE  3: LogFDMonth$ = "Mar"
            CASE  4: LogFDMonth$ = "Apr"
            CASE  5: LogFDMonth$ = "May"
            CASE  6: LogFDMonth$ = "Jun"
            CASE  7: LogFDMonth$ = "Jul"
            CASE  8: LogFDMonth$ = "Aug"
            CASE  9: LogFDMonth$ = "Sep"
            CASE 10: LogFDMonth$ = "Oct"
            CASE 11: LogFDMonth$ = "Nov"
            CASE 12: LogFDMonth$ = "Dec"
        END SELECT

        LogYear$ = STR$(SystemDatum.wYear)

        SELECT CASE LogFormat$
            CASE "XP"
                FUNCTION = LogDay$ + "." + LogXPMonth$ + "." + _
                           RIGHT$(LogYear$,4)
            CASE "FD"
                FUNCTION = LogDayOfWeek$ + " "  + LogDay$ + " " + _
                           LogFDMonth$ + " " + RIGHT$(LogYear$,2)
            CASE ELSE
                FUNCTION = LogDayOfWeek$ + " "  + LogDay$ + " " + _
                           LogFDMonth$ + " " + RIGHT$(LogYear$,2)
        END SELECT

END FUNCTION

'-------------------------------------------------------------------------------------------
' Applikationsverzeichnis finden
'-------------------------------------------------------------------------------------------
SUB Get_AppPath()

        LOCAL CommandLine  AS ASCIIZ PTR
        LOCAL AppExe       AS STRING
        LOCAL i            AS INTEGER
        LOCAL Temp         AS STRING

        CommandLine = GetCommandLine()
        Temp = PARSE$(@CommandLine, " ", 1)
        Temp$ = REMOVE$(Temp$, CHR$(34))
        FOR i% = LEN(Temp$) TO 1 STEP -1
            IF RIGHT$(MID$(Temp$, 1, i%), 1) = "\" THEN EXIT FOR
        NEXT i%
        AppPath$ = MID$(Temp$, 1, i%)
        AppExe$  = MID$(Temp$, i% + 1)

END SUB

'-------------------------------------------------------------------------------------------
' PowerBASIC-String aufbereiten
'-------------------------------------------------------------------------------------------
FUNCTION PBVersion() AS STRING

        LOCAL PBVer   AS STRING

        PBVer$ = TRIM$(HEX$(%PB_REVISION))
        PBVer$ = "PowerBASIC/CC v" + LEFT$(PBVer$, 1) + "." + RIGHT$(PBVer$, 2)
        ' + " Build " + TRIM$(STR$(%pb_revletter))
        FUNCTION = PBVer$

END FUNCTION
